# Make sequence of large focus frames.

real	r, f

artdata

s1 = "demo2.000"
s2 = mktemp ("tmp$iraf")
s3 = mktemp ("tmp$iraf")
j = 1

starlist (s2, 20, "", "", interactive=no, spatial="uniform",
    xmin=1., xmax=512., ymin=1., ymax=512., xcenter=INDEF, ycenter=INDEF,
    core_radius=30., base=0., sseed=j, luminosity="powlaw", minmag=-5.,
    maxmag=0., mzero=-4., power=0.01, alpha=0.74, beta=0.04, delta=0.294,
    mstar=1.28, lseed=j, nssample=100, sorder=10, nlsample=100, lorder=10,
    rbinsize=10., mbinsize=0.5, graphics="stdgraph", cursor="")
print ("	 256	 256	 -5", >> s2)

if (access (s1//1//".imh") == NO) {
    delete ("demo2.dat", verify=no, >& "dev$null")
    list = s2
    while (fscan (list, x, y, z) != EOF) {
	if (nscan() != 3)
	    next
	if (z > -2)
	    next
	printf ("%8.2f %8.2f 101 m\n", x, y, >> "demo2.dat")
    }
} else
    ;

for (i=1; i<=7; i+=1) {
    if (access (s1//i//".imh") == NO) {
	list = s2
	while (fscan (list, x, y, z) != EOF) {
	    if (nscan() != 3)
		next
	    r = sqrt ((x/256-1)**2 + (y/256-1)**2)
	    r = 0.1 + 2 * abs (i - 3.75 * sqrt (1 + (r/2)**2))
	    printf ("%8.2f %8.2f %8.2f demos$ring.dat %8.2f 1 0\n",
		x, y, z, r, >> s3)
	}
	type (s3)

	f = 1000 + 20 * (i - 3.75)
        printf ("Make %s at focus %d\n", s1//i, f)
        mkobjects (s1//i, output="", title="Artificial Focus Frame",
	    ncols=512, nlines=512, header="", background=4., objects=s3,
	    xoffset=0., yoffset=0., star="gaussian", radius=1.5, beta=2.5,
	    ar=1., pa=0., distance=1., exptime=3., magzero=4., gain=2.6,
	    rdnoise=4., poisson=yes, seed=i+j, comments=no)
	hedit (s1//i, "focus", f, add=yes, verify=no, show=no, update=yes)

	delete (s3, verify=no)
    } else
	;
}
list = ""
delete (s2, verify=no)
