include	<error.h>
include	<imhdr.h>
include	<imset.h>
include	<plset.h>


define	MAXBUF		32000	# Maximum buffer for column sections
define	MAXRANGES	20	# Maximum number of ranges

define	MASK	(is_in_range(Memi[$1],$2))	# Matches mask code?


# FIXPIX -- Interpolate over bad columns and lines.

procedure t_fixpix ()

int	list			# List of images
pointer	mask			# Mask image
pointer	linterp			# Mask codes for line interpolation
pointer	cinterp			# Mask codes for column interpolation
pointer	ninterp			# Mask codes for narrow interpolation
pointer	creplace		# Mask codes for constant replacement

int	i, nfix
bool	newmask, streq()
pointer	sp, imname, str, im, pm, pll, plc, immap(), im_pmmap()
int	imtopenp(), imtgetim(), nowhite(),decode_ranges()
errchk	immap, im_pmmap
errchk	fp1_fixpixs, fp1_fixpixi, fp1_fixpixl
errchk	fp1_fixpixr, fp1_fixpixd, fp1_fixpixx

begin
	call smark (sp)
	call salloc (mask, SZ_FNAME, TY_CHAR)
	call salloc (imname, SZ_FNAME, TY_CHAR)
	call salloc (str, SZ_LINE, TY_CHAR)
	call salloc (linterp, 3*MAXRANGES, TY_INT)
	call salloc (cinterp, 3*MAXRANGES, TY_INT)
	call salloc (ninterp, 3*MAXRANGES, TY_INT)
	call salloc (creplace, 3*MAXRANGES, TY_INT)

	# Get task parameters
	list = imtopenp ("images")
	call clgstr ("mask", Memc[mask], SZ_FNAME)
	if (nowhite (Memc[mask], Memc[mask], SZ_LINE) == 0)
	    call error (1, "No mask specified")
	call clgstr ("linterp", Memc[str], SZ_LINE)
	if (nowhite (Memc[str], Memc[str], SZ_LINE) == 0)
	    Memi[linterp] = NULL
	else if (decode_ranges (Memc[str], Memi[linterp], MAXRANGES, i) == ERR)
	    call error (1, "Syntax error in `linterp' parameter")
	call clgstr ("cinterp", Memc[str], SZ_LINE)
	if (nowhite (Memc[str], Memc[str], SZ_LINE) == 0)
	    Memi[cinterp] = NULL
	else if (decode_ranges (Memc[str], Memi[cinterp], MAXRANGES, i) == ERR)
	    call error (1, "Syntax error in `cinterp' parameter")
	call clgstr ("ninterp", Memc[str], SZ_LINE)
	if (nowhite (Memc[str], Memc[str], SZ_LINE) == 0)
	    Memi[ninterp] = NULL
	else if (decode_ranges (Memc[str], Memi[ninterp], MAXRANGES, i) == ERR)
	    call error (1, "Syntax error in `ninterp' parameter")
	call clgstr ("creplace", Memc[str], SZ_LINE)
	if (nowhite (Memc[str], Memc[str], SZ_LINE) == 0)
	    Memi[creplace] = NULL
	else if (decode_ranges (Memc[str], Memi[creplace], MAXRANGES, i) == ERR)
	    call error (1, "Syntax error in `creplace' parameter")

	# Fix the pixels.
	if (streq (Memc[mask], "BPM")) {
	    while (imtgetim (list, Memc[imname], SZ_FNAME) != EOF) {
		iferr (im = immap (Memc[imname], READ_WRITE, 0)) {
		    call erract (EA_WARN)
		    next
		}
		iferr (pm = im_pmmap (Memc[mask], READ_ONLY, im)) {
		    call imunmap (im)
		    call erract (EA_WARN)
		    next
		}
		iferr {
		    newmask = true
		    pll = NULL
		    plc = NULL
		    switch (IM_PIXTYPE(im)) {
		    case TY_SHORT:
			call fp1_fixpixs (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    case TY_INT:
			call fp1_fixpixi (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    case TY_USHORT, TY_LONG:
			call fp1_fixpixl (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    case TY_REAL:
			call fp1_fixpixr (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    case TY_DOUBLE:
			call fp1_fixpixd (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    case TY_COMPLEX:
			call fp1_fixpixx (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    default:
			call fp1_fixpixd (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    }
		    if (nfix == 0)
			call error (1, "No pixels to be fixed")
		} then
		    call erract (EA_WARN)
		call pl_close (pll)
		call pl_close (plc)
		call imunmap (pm)
		call imunmap (im)
	    }
	} else {
	    pm = immap (Memc[mask], READ_ONLY, 0)
	    newmask = true
	    pll = NULL
	    plc = NULL
	    while (imtgetim (list, Memc[imname], SZ_FNAME) != EOF) {
		iferr (im = immap (Memc[imname], READ_WRITE, 0)) {
		    call erract (EA_WARN)
		    next
		}
		iferr {
		    switch (IM_PIXTYPE(im)) {
		    case TY_SHORT:
			call fp1_fixpixs (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    case TY_INT:
			call fp1_fixpixi (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    case TY_USHORT, TY_LONG:
			call fp1_fixpixl (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    case TY_REAL:
			call fp1_fixpixr (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    case TY_DOUBLE:
			call fp1_fixpixd (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    case TY_COMPLEX:
			call fp1_fixpixx (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    default:
			call fp1_fixpixd (pm, im, linterp, cinterp, ninterp,
			    creplace, pll, plc, newmask, nfix)
		    }
		    if (nfix == 0)
			call error (1, "No pixels to be fixed")
		} then
		    call erract (EA_WARN)
		call imunmap (im)
	    }
	    call pl_close (pll)
	    call pl_close (plc)
	    call imunmap (pm)
	}

	call imtclose (list)
	call sfree (sp)
end


# FP_NARROW -- Compute interpolation widths along lines and columns.
# For all bad pixels compute the interpolation width along lines and columns
# and store the values as pixel lists in memory for compactness.  The column
# pixel list is transposed to maximize the compactness since segments will
# have constant values.  This routine is only called the first time the pixel
# lists are needed so that if the interpolation type is not NARROW or there
# are no bad pixels requiring knowledge of the widths then this step can be
# skipped.  Similarly, if there are multiple input images using the same mask
# these pixel lists are only computed the first time the first image requires
# them.

procedure fp_narrow (pm, pll, plc)

pointer	pm			#I Pixel mask pointer
pointer	pll			#O Pixel list of line segment widths
pointer	plc			#O Pixel list of column segment widths

int	c, c1, c2, l, l1, l2, nc, nl, n, ncbuf, npix
short	rl[3,2]
long	v[2]
pointer	pmdes, bp, bp1

bool	pm_empty(), im_pmlne2()
int	imstati()
pointer	pl_create(), imgl2s(), imgs2s()

begin
	# Check for an empty mask.
	pmdes = imstati (pm, IM_PMDES)
	if (pmdes != NULL) {
	    if (pm_empty (pmdes))
		return
	}

	nc = IM_LEN(pm,1)
	nl = IM_LEN(pm,2)

	# Set line oriented interpolation widths.
	v[1] = nc
	v[2] = nl
	pll = pl_create (2, v, 16)
	RL_LEN(rl) = 2
	RL_AXLEN(rl) = nc
	RL_X(rl,2) = 1
	RL_N(rl,2) = nc

	do l = 1, nl {
	    if (pmdes != NULL)
		if (!im_pmlne2 (pm, l))
		    next
	    v[2] = l
	    bp = imgl2s (pm, l) - 1
	    for (c1=1; c1<=nc && Mems[bp+c1]==0; c1=c1+1)
		;
	    while (c1 <= nc) {
		for (c2=c1+1; c2<=nc && Mems[bp+c2]!=0; c2=c2+1)
		    ;
		c2 = c2 - 1
		npix = c2 - c1 + 1
		RL_V(rl,2) = npix
		v[1] = c1
		call plplrs (pll, v, rl, 16, npix, PIX_SRC)
		for (c1=c2+1; c1<=nc && Mems[bp+c1]==0; c1=c1+1)
		    ;
	    }
	}

	# Set column oriented interpolation widths.
	v[1] = nl
	v[2] = nc
	plc = pl_create (2, v, 16)
	RL_LEN(rl) = 2
	RL_AXLEN(rl) = nl
	RL_X(rl,2) = 1
	RL_N(rl,2) = nl

	ncbuf = max (1, MAXBUF / nl)
	c2 = 0
	do c = 1, nc {
	    v[2] = c
	    if (c > c2) {
		c1 = c
		c2 = min (c+ncbuf-1, nc)
		n = c2 - c1 + 1
		bp1 = imgs2s (pm, c1, c2, 1, nl) - n - c1
	    }
	    bp = bp1 + c
	    for (l1=1; l1<=nl && Mems[bp+l1*n]==0; l1=l1+1)
		;
	    while (l1 <= nl) {
		for (l2=l1+1; l2<=nl && Mems[bp+l2*n]!=0; l2=l2+1)
		    ;
		l2 = l2 - 1
		npix = l2 - l1 + 1
		RL_V(rl,2) = npix
		v[1] = l1
		call plplrs (plc, v, rl, 16, npix, PIX_SRC)
		for (l1=l2+1; l1<=nl && Mems[bp+l1*n]==0; l1=l1+1)
		    ;
	    }
	}
end
